var currentUser;
var isLoggedIn;

self.port.on("reset", function() {
    if(!isLoggedIn) {
        init();
    }
});

function init() {
    $("#welcomePage").hide();
    $("#newAccountPage").hide();
    $("#registerAccountPage").hide();
    $("#registerSuccessPage").hide();
    $("#accountPage").hide();
    $("#passcodeResetPage").hide();
    

    self.port.on("accountStatus", function(status, activeAccount) {
        if(status === "success") {
            currentUser = activeAccount;
            $("#welcomePage").hide();
            isLoggedIn = true;
            GoToPage4();
        } else {
            $("#welcomePage").show();
        }
    });
    self.port.emit("getAccountStatus");
}

function GoToPage2() {
    $("#welcomePage").fadeOut();
    $("#newAccountPage").fadeIn();
    self.port.emit("getActiveAccount");
    self.port.on("username", function(username){
        if(username != "") {
            currentUser = username;
            
            var $accounts = $('#accounts');
            if($("#accounts option[value='" + username + "']").text() == "") {
                $accounts.append($('<option>', { value : username }).text(username));
            }
        }
    });
}

function GoToPage3() {
    $("#newAccountPage").fadeOut();
    $("#registerAccountPage").fadeIn();
}

function GoToPage4() {
    $("#accountPage").fadeIn();
    isLoggedIn = true;
    sync();
}

function sync() {
    self.port.emit("getData");
    self.port.on("syncCompleted", function(status, lastSync) {
        if(status === "success") {
            $("#syncStatus").text("Sync complete");
            $("#lastSyncDate").text(lastSync);
        } else {
            $("#syncStatus").text(status);
        }
    });
}

function setupHandlers() {
    init();
    
    $("#getStarted").on("click", GoToPage2);
    
    $("#selectAccount").on("click", function() {
        if($("#accounts").val() != null) {
            GoToPage3();
        }
        else {
            alert("Please select an account to continue");
        }
    });
    
    $("#registerAccount").on("click", function() {
        self.port.emit("registerAccount", $("#deviceName").val(), $("#passcode").val());
        self.port.on("registerResult", function(result) {
            switch(result) {
                case "Invalid Fields":
                    alert("Please check the device name and pass code and try again");
                    break;
                case "Failed - SQL Error":
                    alert("Oops. Something went wrong. Please try again.");
                    break;
                case "Failed - Wrong Pass Code":
                    alert("Please check your passcode and try again");
                    break;
                case "success":
                    $("#registerAccountPage").fadeOut();
                    $("#registerSuccessPage").fadeIn();
                    break;
                default:
                    alert("No idea what the hell happened");
            }
        });
    });
    
    $("#registerCompleted").on("click", function() {
        $("#registerSuccessPage").fadeOut();
        GoToPage4();
    });
    
    $("#syncAccount").on("click", function() {
        sync();
    })
    
    $("#sendPageToPhone").on("click", function() {
        self.port.emit("sendPageToPhone");
        self.port.on("sendToPhoneResult", function(result) {
            if(result != "success") {
                alert("Oops something went wrong. Please try again : " + result);
            }
        });
    });
    
    $("#resetPasscode").on("click", function() { 
        $("#accountPage").fadeOut();
        $("#passcodeResetPage").fadeIn();
    });
    
    $("#resetCode").on("click", function() {
        self.port.emit("resetPasscode", $("#newpasscode").val());
        self.port.on("resetCodeResult", function(result) {
            switch(result) {
                case "Invalid Fields":
                    alert("Please check the device name and pass code and try again");
                    break;
                case "Failed - SQL Error":
                    alert("Oops. Something went wrong. Please try again.");
                    break;
                case "Failed - User Not Found":
                    alert("User not found.");
                    break;
                case "success":
                    $("#passcodeResetPage").fadeOut();
                    $("#accountPage").fadeIn();
                    break;
                default:
                    alert("No idea what the hell happened");
            }
        });
    });
    
    $("#resetBack").on("click", function() {
        $("#passcodeResetPage").fadeOut();
        $("#accountPage").fadeIn();
    });    
}


$(document).ready(function(){

    self.port.on("updateAvailable", function(updateAvailable) {
        console.log(updateAvailable);
        if(updateAvailable) {
            $("#container").html("New version of Baconsync for Firefox available. Please download it <a href='http://quinndamerell.com/Baconit/BaconSync/' target='_blank'>here (http://quinndamerell.com/Baconit/BaconSync/)</a>");
        }
        else {
            setupHandlers();
        }
    });
    self.port.emit("checkVersion");
});