var Widget = require("widget").Widget;
var data = require("self").data;
var ss = require("simple-storage");
var Request = require("request").Request;
var tabs = require("tabs");

const { Unknown } = require('api-utils/xpcom');
const { Cc, Ci } = require('chrome');

var historyService = Components.classes['@mozilla.org/browser/nav-history-service;1'].getService(Components.interfaces.nsINavHistoryService);
var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);  

var API_KEY = "248upvYKd794ZPBhaA3XshPbZsw5j8";
var API_ROOT = "http://www.quinndamerell.com/Baconit/BaconSync/v1/";

var myLoginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
var nsLoginInfo = new Components.Constructor(
    "@mozilla.org/login-manager/loginInfo;1",
    Components.interfaces.nsILoginInfo,
    "init"
);

var passcode;

function getLoginInfo(username) {
    var hostname = 'chrome://baconsync';
    var formSubmitURL = null;
    var httprealm = 'User Registration';
    var password;
     
    try {           
        var myLoginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);

        var logins = myLoginManager.findLogins({}, hostname, formSubmitURL, httprealm);
           
        for (var i = 0; i < logins.length; i++) {
            if (logins[i].username == username) {
                password = logins[i].password;
                break;
            }
        }
        return password;
    }
     
    catch(ex) {
        return "";
    }
}

function removeLoginInfo(username) {
    var hostname = 'chrome://baconsync';
    var formSubmitURL = null;
    var httprealm = 'User Registration';
    try {      
        var passwordManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
        
        var logins = passwordManager.findLogins({}, hostname, formSubmitURL, httprealm);
           
        for (var i = 0; i < logins.length; i++) {
            if (logins[i].username == username) {
                passwordManager.removeLogin(logins[i]);
                break;
            }
        }
    }
    catch(ex) {
        passcode = "";
    }
}

function addLoginInfo(deviceName, newPasscode) {
    removeLoginInfo(deviceName);
    var extLoginInfo = new nsLoginInfo(
        'chrome://baconsync',
        null,
        'User Registration',
        deviceName,
        newPasscode,
        "",
        ""
    );
    myLoginManager.addLogin(extLoginInfo);
    passcode = newPasscode;
}

exports.main = function() {
    passcode = getLoginInfo(ss.storage.deviceName);

    if(ss.storage.storiesRead == undefined) {
        ss.storage.storiesRead = [];
    }
    if(ss.storage.historyList == undefined) {
        ss.storage.historyList = [];
    }
    
    if(ss.storage.version == undefined) {
        ss.storage.version = "1.0.0";
    }

    var panel = require("panel").Panel({
        width: 325,
        height: 475,
        contentURL: data.url("panel.html"),
        contentScriptFile: [data.url("jquery-1.8.0.min.js"), data.url("contentScript.js")],
        onHide: function() {
            panel.port.emit("reset");
        }
    });
    
    panel.port.on("getAccountStatus", function() {
        panel.port.emit("accountStatus", ss.storage.accountStatus, ss.storage.activeAccount);
    })

    panel.port.on("getActiveAccount", function() {
        var tabs = require('tabs');
        var found = false;
        for each (var tab in tabs) {
            if(tab.url.indexOf("reddit.com") != -1) {
                tab.attach({
                    contentScriptFile: data.url("jquery-1.8.0.min.js"),
                    contentScript: 'self.postMessage($(".user").text());',
                    onMessage: function (username) {
                        username = username.substring(0, username.indexOf('(') - 1);
                        username = username.toLowerCase();
                        ss.storage.activeAccount = username;
                        panel.port.emit("username", username);
                        found = true;
                    }
                });
            }
        }
        if(!found) {
            panel.port.emit("username", "");
        }        
    });
    
    panel.port.on("checkVersion", function() {
        var updateUrl = "http://www.quinndamerell.com/Baconit/BaconSync/baconsync-firefox.json";
        
        var checkUpdateRequest = Request({
            url: updateUrl,
            onComplete: function(response) {
                var result = response.json["version"];
                if(result != ss.storage.version) {
                    panel.port.emit("updateAvailable", true);
                } else {
                    panel.port.emit("updateAvailable", false);
                }
            }
        }).get();
    });
    
    panel.port.on("registerAccount", function(deviceName, passcode) {
        var newPasscode = SHA1(ss.storage.activeAccount + passcode);
        ss.storage.deviceName = deviceName;
        
        addLoginInfo(deviceName, newPasscode);
    
        var registerAccountRequest = Request({
            url: API_ROOT + "CheckAccount.php",
            content: {
                "UserName": ss.storage.activeAccount,
                "PassCode": newPasscode,
                "DeviceName": deviceName,
                "DeveloperKey": API_KEY
            },
            onComplete: function(response) {
                var result = response.json["status"];
                ss.storage.accountStatus = result;
                panel.port.emit("registerResult", result);
            }
        }).post();
    });
    
    panel.port.on("sendPageToPhone", function() {
        sendToPhone(tabs.activeTab.url, function(response) {
            var result = response.json["status"];
            panel.port.emit("sendToPhoneResult", result);
            panel.hide();
        });
    });
    
    panel.port.on("resetPasscode", function(newPasscode) {
        var resetPasscodeRequest = Request({
            url: API_ROOT + "SetNewPassCode.php",
            content: {
                "UserName": ss.storage.activeAccount,
                "PassCode": newPasscode,
                "DeveloperKey": API_KEY
            },
            onComplete: function(response) {
                var result = response.json["status"];
                if(result == "success") {
                    addLoginInfo(ss.storage.deviceName, newPasscode);
                }
                panel.port.emit("resetCodeResult", result);
            }
        }).post();
    });

    panel.port.on("getData", function() {
        syncData();
    });
    
    function sendToPhone(url, onComplete) {
        var sendToPhoneRequest = Request({
            url: API_ROOT + "SendUrlToPhone.php",
            content: {
                "UserName": ss.storage.activeAccount,
                "PassCode": passcode,
                "URL": url,
                "DeveloperKey": API_KEY
            },
            onComplete: onComplete 
        }).post();
    }
    
    function syncData() {              
        function onSyncComplete(response) {
            var result = response.json["status"];
            switch(result) {
                case "Invalid Fields":
                case "Failed - SQL Error":
                case "Failed - Wrong Pass Code":
                    panel.port.emit("syncCompleted", result);
                    break;
                case "success":
                    ss.storage.storiesRead = [];
                    var redditIDList = response.json["RedditIDList"];
                    redditIDList = redditIDList.map(function(entry) { return entry["RedditID"]; });                                                            
                    if(redditIDList) {
                        if(!ss.storage.historyList) {
                            ss.storage.historyList = [];
                        }
                        ss.storage.historyList = ss.storage.historyList.concat(redditIDList);
                    }                    
                    ss.storage.lastSync = new Date();                    
                    panel.port.emit("syncCompleted", result, ss.storage.lastSync.toLocaleDateString() + " - " + ss.storage.lastSync.toLocaleTimeString());
                    break;
            }
        }
        if(typeof ss.storage.storiesRead != "undefined" && ss.storage.storiesRead.length > 0) {
            var syncDataRequest = Request({
                url: API_ROOT + "ReportAndGetRedditIDs.php",
                content: {
                    "UserName": ss.storage.activeAccount,
                    "PassCode": passcode,
                    "DeviceName": ss.storage.deviceName,
                    "DeveloperKey": API_KEY,
                    "RedditIDList": ss.storage.storiesRead.toString()
                },
                onComplete: onSyncComplete
            }).post();
        } else {
            var syncDataRequest = Request({
                url: API_ROOT + "ReportAndGetRedditIDs.php",
                content: {
                    "UserName": ss.storage.activeAccount,
                    "PassCode": passcode,
                    "DeviceName": ss.storage.deviceName,
                    "DeveloperKey": API_KEY
                },
                onComplete: onSyncComplete
            }).post();
        }
    }

    var widget = new Widget({
        id: "baconsync-widget",
        label: "BaconSync",
        contentURL: data.url("logo16.png"),        
        panel: panel
    });  
    
    tabs.on('open', function(tab){
        tab.on('ready', function(tab){
            if(tab.url.indexOf("reddit.com") != -1) {
                tab.on('close', function() {
                    syncData();
                });
            }
        });
    });
    
    var pageMod = require("page-mod");
    pageMod.PageMod({
        include: "*.reddit.com",
        contentScriptFile: data.url("jquery-1.8.0.min.js"), 
        contentScript: '$("a").click(function() { var storyId = $(this).parent().parent().parent().data("fullname"); if(storyId != "undefined") { self.port.emit("newStory", storyId); } });',
        onAttach: function(worker) {
            worker.port.on("newStory", function(storyId) {
                if(storyId != "") {
                    if(typeof ss.storage.storiesRead == "undefined") { 
                        ss.storage.storiesRead = [];
                    }
                    ss.storage.storiesRead.push(storyId);
                }
            });
        }
    });
    pageMod.PageMod({
        include: "*.reddit.com",
        contentScriptFile: [data.url("jquery-1.8.0.min.js"), data.url("pageModScript.js")],
        onAttach: function(worker) {
            worker.port.on("getReadList", function() {
                if(ss.storage.historyList && ss.storage.historyList.length > 0) {
                    worker.port.emit("readList", ss.storage.historyList);
                }
            });
            
            worker.port.on("addUrlToHistory", function(url, index) {
                var uri = ioService.newURI(url, null, null); 
                historyService.addVisit(uri, Date.now(), null, false, 1, 0);
                ss.storage.historyList.splice(index, 1);
            });
        }
    });
    
    var cm = require("context-menu");
    cm.Item({
        label: "Send to phone via BaconSync",
        image: data.url("logo16.png"),
        context: cm.SelectorContext("a"),
        contentScript: 'self.on("click", function (node, data) {' +
                       '    self.postMessage(node.href);' +
                       '});',
        onMessage: function (url) {
            sendToPhone(url, function(response) {
                var result = response.json["status"];
                if(result != "success") {
                    alert(result);
                }
            });
        }
    });
};

function SHA1 (msg) { 
    function rotate_left(n,s) {
    	var t4 = ( n<<s ) | (n>>>(32-s));
		return t4;
	}; 
	function lsb_hex(val) {
		var str="";
		var i;
		var vh;
		var vl;
 
		for( i=0; i<=6; i+=2 ) {
			vh = (val>>>(i*4+4))&0x0f;
			vl = (val>>>(i*4))&0x0f;
			str += vh.toString(16) + vl.toString(16);
		}
		return str;
	}; 
	function cvt_hex(val) {
		var str="";
		var i;
		var v;
 
		for( i=7; i>=0; i-- ) {
			v = (val>>>(i*4))&0x0f;
			str += v.toString(16);
		}
		return str;
	}; 
	function Utf8Encode(string) {
		string = string.replace(/\r\n/g,"\n");
		var utftext = "";
 
		for (var n = 0; n < string.length; n++) {
 
			var c = string.charCodeAt(n);
 
			if (c < 128) {
				utftext += String.fromCharCode(c);
			}
			else if((c > 127) && (c < 2048)) {
				utftext += String.fromCharCode((c >> 6) | 192);
				utftext += String.fromCharCode((c & 63) | 128);
			}
			else {
				utftext += String.fromCharCode((c >> 12) | 224);
				utftext += String.fromCharCode(((c >> 6) & 63) | 128);
				utftext += String.fromCharCode((c & 63) | 128);
			} 
		} 
		return utftext;
	}; 
	var blockstart;
	var i, j;
	var W = new Array(80);
	var H0 = 0x67452301;
	var H1 = 0xEFCDAB89;
	var H2 = 0x98BADCFE;
	var H3 = 0x10325476;
	var H4 = 0xC3D2E1F0;
	var A, B, C, D, E;
	var temp; 
	msg = Utf8Encode(msg); 
	var msg_len = msg.length; 
	var word_array = new Array();
	for( i=0; i<msg_len-3; i+=4 ) {
		j = msg.charCodeAt(i)<<24 | msg.charCodeAt(i+1)<<16 |
		msg.charCodeAt(i+2)<<8 | msg.charCodeAt(i+3);
		word_array.push( j );
	} 
	switch( msg_len % 4 ) {
		case 0:
			i = 0x080000000;
		break;
		case 1:
			i = msg.charCodeAt(msg_len-1)<<24 | 0x0800000;
		break;
 
		case 2:
			i = msg.charCodeAt(msg_len-2)<<24 | msg.charCodeAt(msg_len-1)<<16 | 0x08000;
		break;
 
		case 3:
			i = msg.charCodeAt(msg_len-3)<<24 | msg.charCodeAt(msg_len-2)<<16 | msg.charCodeAt(msg_len-1)<<8	| 0x80;
		break;
	} 
	word_array.push( i ); 
	while( (word_array.length % 16) != 14 ) word_array.push( 0 ); 
	word_array.push( msg_len>>>29 );
	word_array.push( (msg_len<<3)&0x0ffffffff ); 
	for ( blockstart=0; blockstart<word_array.length; blockstart+=16 ) { 
		for( i=0; i<16; i++ ) W[i] = word_array[blockstart+i];
		for( i=16; i<=79; i++ ) W[i] = rotate_left(W[i-3] ^ W[i-8] ^ W[i-14] ^ W[i-16], 1); 
		A = H0;
		B = H1;
		C = H2;
		D = H3;
		E = H4; 
		for( i= 0; i<=19; i++ ) {
			temp = (rotate_left(A,5) + ((B&C) | (~B&D)) + E + W[i] + 0x5A827999) & 0x0ffffffff;
			E = D;
			D = C;
			C = rotate_left(B,30);
			B = A;
			A = temp;
		}
 
		for( i=20; i<=39; i++ ) {
			temp = (rotate_left(A,5) + (B ^ C ^ D) + E + W[i] + 0x6ED9EBA1) & 0x0ffffffff;
			E = D;
			D = C;
			C = rotate_left(B,30);
			B = A;
			A = temp;
		}
 
		for( i=40; i<=59; i++ ) {
			temp = (rotate_left(A,5) + ((B&C) | (B&D) | (C&D)) + E + W[i] + 0x8F1BBCDC) & 0x0ffffffff;
			E = D;
			D = C;
			C = rotate_left(B,30);
			B = A;
			A = temp;
		}
 
		for( i=60; i<=79; i++ ) {
			temp = (rotate_left(A,5) + (B ^ C ^ D) + E + W[i] + 0xCA62C1D6) & 0x0ffffffff;
			E = D;
			D = C;
			C = rotate_left(B,30);
			B = A;
			A = temp;
		}
 
		H0 = (H0 + A) & 0x0ffffffff;
		H1 = (H1 + B) & 0x0ffffffff;
		H2 = (H2 + C) & 0x0ffffffff;
		H3 = (H3 + D) & 0x0ffffffff;
		H4 = (H4 + E) & 0x0ffffffff; 
	}
 
	var temp = cvt_hex(H0) + cvt_hex(H1) + cvt_hex(H2) + cvt_hex(H3) + cvt_hex(H4);
 
	return temp.toLowerCase();
 
}